﻿var setPostContent,
    addMoreReply,
    clickLike,
    showClickLike,
    delReply,
    delComment,
    delTopic,
    gotoUserHome,
    postComment,
    rawImg;
$(function () {

    //------------------------初始化-----------------------------
    var app, isLoading;
    var floorCount = 0;


    //初始简化app对应接口
    if (window.hasOwnProperty("TopicDetailsJsInterface")) {
        app = window.TopicDetailsJsInterface;
    }
    //添加下拉刷新行为
    var droploadList = $('#lists').dropload({
        scrollArea: window,
        domDown: {                                                          // 下方DOM
            domClass: 'dropload-down',
            domRefresh: '',
            domLoad: '<div class="dropload-load"><span class="loading"></span>加载中...</div>',
            domNoData: '<div class="dropload-noData"></div>'
        },
        loadDownFn: function (me) {
            if (app) {
                if (isLoading) {
                    return;
                }
                isLoading = true;
                app.loadNextData();
            }
        }
    });

    //处理可能不支持导致的window没有高度
    $(document).ready(function () {
        $(window).load(function () {
            if ($(window).height() == 0) {
                $('.dropload-down').append('<div class="dropload-noData"><div class="nosofa"></div></div>');
                isLoading = true;
                app.loadNextData();
            }
        });
    });

    //----------------------android接口-----------------
    /**
     * 设置帖子内容
     *
     * @param avatar        头像
     * @param uid           uid
     * @param nick          昵称
     * @param time          日期
     * @param replyCount    回复数量
     * @param title         标题
     * @param message       内容
     * @param likeCount     点赞人数
     * @param like          是否已点赞
     *
     */
    setPostContent = function (avatar, uid, nick, time, replyCount, isAdmin, title, message, likeCount, like) {
        floorCount++;
        var html = '<div class="user">\
            <a href="javascript:gotoUserHome(\'' + uid + '\',\'' + nick + '\')"><img src="' + avatar + '"></a>\
                <div class="fl">\
                    <p>' + nick + '<i class="host">楼主</i></p>\
                    <p><span>' + time + '</span><span>评论<em>' + replyCount + '</em></span></p>'
            + (isAdmin == 1 ? ('<div class="down"><i class="jt"></i><a href="javascript:delTopic()" class="del">删除</a></div>') : ('')) +
            '</div>\
        </div>\
        <div class="con">\
        <div class="tit">' + title + '</div>\
            <p class="msg">' + message + '</p>\
            <center><div id="like">' + (like == 1 ? ('<a class="zan zaned">' + likeCount + '</a>') : ('<a href="javascript:clickLike()" class="zan">' + likeCount + '</a>')) + '</div></center>\
            <div class="lou">' + floorCount + '楼</div>';
        $("#post-info").html(html);
    };

    /**
     * 加载更多回复
     * @param json          json数据字符串
     * @returns {boolean}
     */
    addMoreReply = function (json) {
        var jsonData = eval('(' + json.toString() + ')');
        var replys = jsonData.data;
        var result = "";
        var lng = replys.length;
        for (var i = 0; i < lng; i++) {
            var reply = replys[i];
            floorCount++;
            result += '<li>\
                <div class="b pl">\
                <div class="user">\
                <a href="javascript:gotoUserHome(\'' + reply.uid + '\',\'' + reply.nick + '\')"><img src="' + reply.avatar + '"/></a>\
                    <div class="fl">\
                        <p>' + reply.nick +
                ((floorCount == 2) ? '<i class="sofa">沙发</i>' : '') +
                (reply.host ? '<i class="host">楼主</i>' : '') +
                '</p>\
                <p><span>' + reply.time + '</span></p>'
                + (reply.admin ? ('<div class="down"><i class="jt"></i><a href="javascript:delReply(' + reply.id + ')" class="del">删除</a></div>') : '') +
                '</div></div>\
            <div class="con">\
                <p>' + reply.message + '</p>\
                    <div class="lou">' + floorCount + '楼</div>\
                    <a href="javascript:postComment(' + reply.id + ',' + reply.uid + ',\'' + reply.nick + '\')" class="plico fr"></a>\
                </div>';
            var comments = reply.comments;
            var clng = comments.length;
            if (clng != 0) {
                result += '<div class="plcon">';
                for (var j = 0; j < clng; j++) {
                    var comment = comments[j];
                    result += '<p><a href="javascript:gotoUserHome(\'' + comment.uid + '\',\'' + comment.nick + '\')">' + comment.nick + '</a>：<i>' + comment.message + '</i></p>';
                }
                result += '</div>';
            }
            result += '</div>';
            result += '</li>';
        }
        $('#post-list').append(result);
        if (jsonData.page >= jsonData.totalpage) {
            droploadList.lock();
            droploadList.noData();
        }
        droploadList.resetload();
        if (jsonData.totalpage == 0) {
            $('.dropload-noData').html('<div class="nosofa"></div>');
        } else {
            $('.dropload-noData').html('');
        }
        isLoading = false;
        $(".down i").click(function () {
            if ($(this).siblings("a").is(":hidden")) {
                $(this).siblings("a").slideDown();//.show();
                $(document).on("touchend", function (e) {
                    var _class = $(e.target).attr("class");
                    if (_class != "del" && _class != "jt") {
                        $(".del").slideUp();//.hide();
                        $(document).off("touchend");
                    }
                });
            } else {
                $(this).siblings(".del").slideUp();//.hide();
            }
        });
        $(".del").click(function () {
            $(this).hide();
        });
    }
    //----------------------JS接口----------------------
    /**
     * 点赞
     */
    clickLike = function () {
        app.clickLike();
    };

    /**
     * 显示点赞动画
     */
    showClickLike = function (ani) {
        if (!$(".zan").hasClass("zaned")) {
            if (ani == 1) {
                var a = parseInt($(".zan").html()) + 1;
                $(".zan").html(a + "<i>+1</i>");
                setTimeout(function () {
                    $(".zaned i").hide();
                }, 800);
            }
            $(".zan").addClass("zaned");
        }
    };

    /**
     * 删除回帖
     * @param replyId
     */
    delReply = function (replyId) {
        app.delReply("" + replyId);
    };

    /**
     * 删除评论
     * @param commentId
     */
    delComment = function (commentId) {
        app.delComment("" + commentId);
    };

    /**
     * 发布评论
     * @param commentId
     * @param uid
     * @param nick
     */
    postComment = function (commentId, uid, nick) {
        app.postComment("" + commentId, "" + uid, "" + nick);
    };

    /**
     * 删除话题
     */
    delTopic = function () {
        app.delTopic();
    };

    /**
     * 跳转到用户界面
     * @param userId
     */
    gotoUserHome = function (userId, userName) {
        app.gotoUserHome(userId, userName);
    };

    //----------------------HTML显示效果----------------
    /**
     *  图片点击处理
     */
    rawImg = function (imageId, img) {
        if ($(img).parent('a').length > 0) return true;
        open("http://p.img4399.com/" + imageId + "/1");
        return true;
    };
});
